package com.css.txw.sso.service.auth;

import com.css.txw.mhzc.pojo.YhxxbDTO;
import com.css.txw.sso.pojo.vo.AuthLoginReqVO;
import com.css.txw.sso.pojo.vo.AuthLoginRespVO;
import com.css.txw.sso.pojo.vo.DidBindPhoneReqVO;
import com.css.txw.sso.pojo.vo.SMSLoginReqVO;
import com.css.txw.sso.pojo.vo.SendMsgReqVO;
import com.css.txw.sso.pojo.vo.oauth2.LogoutVO;

import javax.validation.Valid;
import java.util.List;

public interface AuthService {

    /**
     * 验证账号 + 密码。如果通过，则返回用户
     *
     * @param username 账号
     * @param password 密码
     * @return 用户
     */
    YhxxbDTO authenticate(String username, String password);

    /**
     * 账号登录
     *
     * @param reqVO 登录信息
     * @return 登录结果
     */
    AuthLoginRespVO login(@Valid AuthLoginReqVO reqVO);


    /**
     * 基于 token 退出登录
     *
     * @param token token
     * @param logType 登出类型
     */
    List<LogoutVO> logout(String token, Integer logType);

    /**
     * 刷新访问令牌
     *
     * @param refreshToken 刷新令牌
     * @return 登录结果
     */
    AuthLoginRespVO refreshToken(String refreshToken);

    Integer sendMsg(SendMsgReqVO reqVO) throws Exception;

    AuthLoginRespVO loginBySMS(SMSLoginReqVO reqVO);

	AuthLoginRespVO didBindPhone(@Valid DidBindPhoneReqVO reqVO);
} 
